<script setup lang="ts">
import { ref } from 'vue';
import NavigationCard from './NavigationCard.vue';
import NavigationDropdownFooter from './NavigationDropdownFooter.vue';
import NavigationDropdownList from './NavigationDropdownList.vue';
import ChevronIcon from '~/assets/icons/chevron.vue';
import CloseIcon from '~/assets/icons/close.vue';
import { Gitlab } from 'slippers-ui/icons';
import UserIcon from '~/assets/icons/user.vue';
import CommentIcon from '~/assets/icons/comment.vue';
import type { MainNavigation } from '@/types/navigation';

const props = defineProps<{
  navigationData: MainNavigation;
  hideSalesButton: boolean;
}>();

const activeTitle = ref('');
const navItems = ref(props.navigationData.items);
const sectionIndex = ref(-1);
const isDropdownOpen = ref(false);

const setActiveNavItem = (index: number) => {
  sectionIndex.value = index;
  activeTitle.value = navItems.value[index].text;
  isDropdownOpen.value = true;
};

const back = () => {
  sectionIndex.value = -1;
  activeTitle.value = '';
  isDropdownOpen.value = false;
};
const emit = defineEmits(['onClose']);
</script>

<template>
  <div class="be-nav-mobile-menu">
    <div :class="{ 'slp-mb-24': !isDropdownOpen }">
      <div>
        <!-- Top Logo Menu -->
        <div class="be-nav-mobile-menu-top_logo">
          <SlpButton
            variant="icon"
            :href="navigationData.logo.config.href"
            data-nav="logo"
            aria-label="Home"
            name="Home"
            :data-ga-name="navigationData.logo.config.dataGaName"
            :data-ga-location="navigationData.logo.config.dataGaLocation"
          >
            <SlpIcon :icon="Gitlab" size="lg" aria-id="tanukiHomeMobileMenu" />
          </SlpButton>
          <SlpButton variant="icon" aria-label="Close dropdown" @click="emit('onClose')">
            <CloseIcon fill="#171321" />
          </SlpButton>
        </div>
        <!-- Section Menu back button -->
        <div v-if="!(sectionIndex && sectionIndex === -1)" class="slp-flex">
          <div class="be-nav-mobile-menu-top_back">
            <SlpButton variant="ghost" name="Go Back" @click="back()">
              <ChevronIcon class="slp-mr-8" direction="left" />
              <SlpTypography variant="body1" tag="span">
                {{ activeTitle }}
              </SlpTypography>
            </SlpButton>
          </div>
        </div>
      </div>
      <div>
        <!-- First Level Menu -->
        <div v-for="(item, index) in navItems" :key="item.text" class="slp-flex">
          <SlpButton
            v-show="!isDropdownOpen"
            tag="li"
            variant="ghost"
            class="be-nav-mobile-menu-item"
            :href="item.cards || item.lists ? '' : item.config.href"
            :name="item.text"
            :data-ga-name="item.config.dataGaName"
            :data-ga-location="item.config.dataGaLocation"
            @click="item.cards || item.lists ? setActiveNavItem(index) : ''"
          >
            <SlpTypography tag="span" variant="body1">
              <span>{{ item.text }}</span>
            </SlpTypography>
            <ChevronIcon v-if="item.cards || item.lists" direction="right" />
          </SlpButton>
        </div>
        <!-- Second Level Menu -->
        <div v-if="isDropdownOpen">
          <div v-if="navItems[sectionIndex].cards" class="navigation-dropdown__cards">
            <NavigationCard
              v-for="card in navItems[sectionIndex].cards"
              :key="card.title"
              v-bind="{ ...card, ...navItems[sectionIndex].config }"
            ></NavigationCard>
          </div>
          <NavigationDropdownList
            v-if="navItems[sectionIndex].lists"
            v-bind="navItems[sectionIndex]"
          ></NavigationDropdownList>

          <NavigationDropdownFooter
            v-if="navItems[sectionIndex].footer"
            v-bind="{ ...navItems[sectionIndex].footer, ...navItems[sectionIndex].config }"
          />
        </div>
        <!-- Sign In Button -->
        <div v-if="sectionIndex && sectionIndex === -1" class="slp-flex slp-mt-16">
          <SlpButton
            variant="ghost"
            class="be-nav-mobile-menu-item be-nav-mobile-menu-item--icon-btn"
            :name="navigationData.login.text"
            :href="navigationData.login.config.href"
            :data-ga-name="navigationData.login.config.dataGaName"
            :data-ga-location="navigationData.login.config.dataGaLocation"
            :data-nav="navigationData.login.config.dataGaName"
          >
            <div class="slp-flex slp-align-items-center">
              <UserIcon class="slp-mr-8" />
              <SlpTypography tag="span" variant="body1">
                {{ navigationData.login.text }}
              </SlpTypography>
            </div>
          </SlpButton>
        </div>
        <!-- Talk to an expert button -->
        <div v-if="sectionIndex && sectionIndex === -1 && !hideSalesButton" class="slp-flex">
          <SlpButton
            :href="navigationData.sales.config.href"
            variant="ghost"
            class="be-nav-mobile-menu-item be-nav-mobile-menu-item--icon-btn"
            :data-ga-name="navigationData.sales.config.dataGaName"
            :data-ga-location="navigationData.sales.config.dataGaLocation"
            :data-nav="navigationData.sales.config.dataGaName"
          >
            <div class="slp-flex slp-align-items-center">
              <CommentIcon class="slp-mr-8" />
              <SlpTypography tag="span" variant="body1">
                {{ navigationData.sales.text }}
              </SlpTypography>
            </div>
          </SlpButton>
        </div>
      </div>
    </div>
    <!-- Free trial button -->
    <SlpButton
      v-show="!isDropdownOpen"
      :href="navigationData.freeTrial.config.href"
      variant="primary"
      class="be-nav-mobile-menu-bottom"
      :name="navigationData.freeTrial.text"
      :data-ga-name="navigationData.freeTrial.config.dataGaName"
      :data-ga-location="navigationData.freeTrial.config.dataGaLocation"
      :data-nav="navigationData.freeTrial.config.dataGaName"
    >
      {{ navigationData.freeTrial.text }}
    </SlpButton>
  </div>
</template>

<style lang="scss" scoped>
.be-nav-mobile-menu {
  position: fixed;
  background-color: $color-surface-50;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  display: flex;
  flex-direction: column;
  max-width: 100vw;
  overflow-x: hidden;

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  .w-100 {
    width: 100%;
  }

  &__login {
    display: flex;
    flex-direction: column;
    margin: $spacing-24 $spacing-16 0 $spacing-16;
    text-align: center;
  }

  &-top {
    &_back,
    &_logo {
      display: flex;
      align-items: center;
      justify-content: space-between;
      width: 100%;
      padding: 0 $spacing-8;
    }

    &_back {
      border-bottom: 1px solid $color-surface-300;
      margin: 0 $spacing-16;
      display: flex;
      padding: 0;

      &:deep(.slp-btn) {
        padding: $spacing-8 0;
      }
    }
  }

  &-bottom {
    display: flex;
    justify-content: center;
    margin: $spacing-8 $spacing-16;
  }

  &-item {
    width: 100%;
    border-radius: 0px !important;
    justify-content: space-between;
    border-bottom: 1px solid $color-surface-300 !important;
    padding: $spacing-8 0 !important;
    color: $color-primary-200;
    margin: 0 $spacing-16;
    display: flex;

    &--sub {
      margin-left: $spacing-32;
    }

    &--icon-btn {
      padding: $spacing-16 0 !important;
    }

    &__dropdown {
      background: $color-surface-100 !important;
    }

    a {
      color: $color-text-300;
    }

    span {
      text-align: start;
    }
  }

  &__bottom-section {
    display: flex;
    flex-direction: column;
    padding: $spacing-24;
    background-color: $color-surface-800;

    h5,
    p {
      color: $color-text-300;
    }
  }

  &__image {
    max-width: 375px;
  }

  &__image,
  &__logo {
    margin-bottom: $spacing-16;
    width: 100%;
    display: flex;
    justify-content: center;
    border-radius: $border-radius-4 $border-radius-4 100% $border-radius-4;
    background-color: $color-primary-300;

    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }

  &__logo {
    padding: 12px;
    box-sizing: border-box;

    img {
      object-fit: contain;
    }
  }

  &__icon {
    margin-bottom: $spacing-16;
    color: $color-text-300;
  }

  &__side-link {
    padding-left: 0 !important;
    padding-bottom: 0 !important;

    &-small {
      font-size: 14px !important;
    }
  }

  // Explicitly set span color to fix iOS 15 safari bug
  span {
    color: $color-text-300;
  }

  .logos-container {
    width: 100%;
  }

  .logos {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: $spacing-16;

    &_image {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 64px;
      height: 64px;
    }

    svg {
      height: 100%;
      width: 100%;
    }
  }
}
</style>
